from __future__ import with_statement
print "b236"
os.chdir("/home/rlmill/sage/aly_notebook/worksheets/admin/5/cells/2")
def Initialize(Basis_Matrix):
#Input:
#    Basis_Matrix -- n by n matrix
#Output:
#    basis_star -- n by n matrix
#    mue -- n by n matrix
#    k -- integer
#    k_max -- integer
#    B -- list of length n
#    H -- n by n identity matrix

    B = [Integer(0) for i in range(Basis_Matrix.nrows())] #this is the list of dot products of rows
    B[Integer(0)] = (Basis_Matrix[Integer(0)])*(Basis_Matrix[Integer(0)]) #initializing the first entry

    basis_star = matrix(QQ,Basis_Matrix.nrows(),Basis_Matrix.ncols())
    basis_star[Integer(0)] = Basis_Matrix[Integer(0)]
    basis_star = matrix(basis_star)

    meu = matrix(QQ,Basis_Matrix.nrows(),Basis_Matrix.ncols())

    k = Integer(1)
    k_max = Integer(0)

    H = identity_matrix(Basis_Matrix.nrows())

    return(basis_star,meu,k,k_max,B,H)

print "e236"
