from __future__ import with_statement
print "b256"
os.chdir("/home/rlmill/sage/aly_notebook/worksheets/admin/5/cells/1")
def SWAP(k,k_max,meu,B,Basis_Matrix,basis_star,H):
#this is the algorithm that assures the second LLL criteria is reached
#Input:
#    k -- integer < Basis_Matrix.nrows()= n
#    l -- integer < k
#    mue -- n by n matrix
#    B -- list of length n
#    Basis_Matrix -- n by n matrix
#    basis_star -- n by n matrix
#    H -- n by n matrix
#Output:
#    mue -- n by n matrix
#    B -- list of length n
#    basis_star -- n by n matrix
#    Basis_Matrix -- n by n matrix
#    H -- n by n matrix

    basis_swap = Basis_Matrix
    Basis_Matrix.swap_rows(k,k-Integer(1))

    H1 = H
    H.swap_rows(k,k-Integer(1))

    meu_swap = copy(meu)

    if k > Integer(0):
        for i in range(k-Integer(1)):

            meu[k,i] = meu_swap[k-Integer(1),i]
            meu[k-Integer(1),i] = meu_swap[k,i]

    meu_entry = meu[k,k-Integer(1)]
    B_swap = B[k] + meu_entry**Integer(2)*B[k-Integer(1)]
    meu[k,k-Integer(1)] = meu_entry*B[k-Integer(1)]/B_swap


    basis_entry = basis_star[k-Integer(1)]
    basis_star = basis_star.rows()
    basis_star[k-Integer(1)] = basis_star[k]+meu_entry*basis_entry
    basis_star[k] = -meu[k,k-Integer(1)]*basis_star[k] + B[k]/B_swap*basis_entry
    basis_star = matrix(basis_star)


    B[k] = B[k-Integer(1)]*B[k]/B_swap
    B[k-Integer(1)] = B_swap

    for i in range(k+Integer(1),k_max+Integer(1)):
        t = meu[i,k]
        meu[i,k] = meu[i,k-Integer(1)] - meu_entry*t
        meu[i,k-Integer(1)] = t + meu[k,k-Integer(1)]*meu[i,k]

    return(meu,B,basis_star,Basis_Matrix,H)

print "e256"
